/*
Questa versione del programma non usa l'allocazione
dinamica per il vettore dei numeri.
Peranto e' in grado di gestire un numero di
valori pari a 10 come indicato nella dichiarazione
del vettore "value".
Vedere il file leggi_file_malloc.c per la versione
del programma che usa la memoria dinamica e confrontare
le 2 alternative.
*/

#include <stdio.h>

int main(int arg, char *args[]) {

    FILE *source;   /*dichiarazione del puntatore a FILE*/
    FILE *dest;
    int i;          /*indice per lo scorrimento del vettore*/

    /*
    Il vettore ha dimensione fissa e pu contenere solo 10 interi!!
    Ricordare che il nome del vettore  un puntatore.
    */
    int value[10];  /*dichiarazione statica di un vettore di 10 interi*/ 
    
    float med = 0;  /*dichiarazione della variabile per la media*/
    
    if(arg != 3)    /*per stampare il modo d'uso del programma*/
        printf("\nUsage: leggi_file.x <source file> <dest file>\n\n");
    else {
        source = fopen(args[1], "r");   /*apertura del file sorgente*/
        /*controllo che il file sia stato aperto
          la fopen ritorna NULL in caso di errore*/
        if(source == NULL)
            printf("Errore nell'apertura. File non trovato.\n");
        else {                        
            for(i=0; i<10; i++) {
                /*lettura dal file sorgente*/
                fscanf(source, "%d", &value[i]);
                /*
                Avrei potuto scrivere anche
                fscanf(source, "%d", value+i); ????
                */
            }       
            /*chiusura del file*/        
            fclose(source);
            
            /*calcolo della media*/
            for(i=0; i<10; i++)
                med += value[i];
                /*
                Avrei potuto scrivere anche
                med += *(value+i); ????
                oppure 
                med += *value[&i]; ????
                */          
                
            med /= 10;          
            
            /*apertura del file destinazione*/
            dest = fopen(args[2], "w");
            
            /*scrittura su file*/
            for(i=0; i<10; i++)
                fprintf(dest, "%d\n", value[i]);                
            
            fprintf(dest, "Media = %f\n", med);                         
            
            /*chiusura del file*/
            fclose(dest);
    
            printf("Operazione effettuata. I valori sono stati salvati sul file %s\n\n",args[2]);
        }
    }       
}
