#include <stdio.h>
#include <stdlib.h>

/*Struttura dati per memorizzare le informazioni
relative a nome, cognome et.
Notare che la struttura contiene un puntatore
a una variabile dello stesso tipo di struttura per
poter implementare la lista.*/
typedef struct record_anag {
        char name[20];
        char last_name[20];
        int age;        
        struct record_anag *next;
    } rec;

/*dichiarazione delle due funzioni*/
rec *registra();
void stampa(FILE *f, rec *lista);

int main(int arg, char *args[]) {
    FILE *dest;
    char c;
    rec *head;  /*puntatore alla testa della lista*/
    rec *p;     /*puntatore ad un elemento*/

    if(arg != 2)
        printf("\nUsage: anagrafica.x <filename>\n\n");
    else {
        
        /*chiamata alla funzione registra per 
        la creazione del primo elemento della lista*/
        head = registra();      
        
        /*p punta alla testa*/
        p = head;
        
        printf("Un altro record? [s/n]\n");         
    
        /* per leggere un carattere che sia 's' o 'n'*/
        do {
            c = getchar();
        } while (c != 's' && c != 'n');
        
        while(c =='s') {
        
            /*crea un nuovo elemento chiamando la 
            funzione registra e lo appende in coda
            alla lista*/
            p->next = registra();
            p = p->next;    /*sposto il puntatore p alla fine della lista*/
            
            printf("Un altro record? [s/n]\n");         
            
            do {
                c = getchar();
            } while (c != 's' && c != 'n');
        }
        
        dest = fopen(args[1],"w");
        stampa(dest, head); /*stampa la lista sul file*/
        printf("Elenco dei record memorizzato nel file %s \n", args[1]);        
        fclose (dest);
    }
    
}

/*definizione della funzione registra.
Non servono parametri.
La funzione ritorna un puntatore all'elemento
appena creato*/
rec *registra() {
        
        /*allocazione della memoria per un nuovo elemento
        tramite la funzione malloc*/
        rec *node = (rec *) malloc(sizeof(rec));

        /*inserimento dei dati nei campi della struttura*/
        printf("Inserire il nome (max 20 car.)\n");
        scanf("%s", node->name);
        printf("Inserire il cognome (max 20 car.)\n");
        scanf("%s", node->last_name);
        printf("Inserire l'eta\n");
        scanf("%d", &(node->age));    
        
        node->next = NULL;
    
        return node;

}

/*definizione della funzione stampa.
Parametri: file su cui stampare
e puntatore alla testa della lista da stampare*/
void stampa(FILE *f, rec *lista) {

        rec *p; /*puntatore ad un elemento della lista*/
        
        p = lista;
        
        fprintf(f, "Elenco dei record memorizzati \n");
        fprintf(f, "*******************\n");    
        
        /*scorrimento della lista per la stampa degli
        elementi fino a che p punta a NULL, ovvero
        fino a quando non arrivo in fondo alla lista*/
        while (p != NULL) {
            fprintf(f,"nome = %s\n", p->name);
            fprintf(f,"cognome = %s\n", p->last_name);
            fprintf(f,"eta' = %d\n", p->age);   
            fprintf(f, "*******************\n");    
            
            p = p->next;
        }
        
        return;
}
